### Hierarchy

- <internal>.WebSocketAlias
  - WebSocket

## Index

### Properties

- CLOSED
- CLOSING
- CONNECTING
- OPEN
- binaryType
- bufferedAmount
- extensions
- isPaused
- onclose
- onerror
- onmessage
- onopen
- protocol
- readyState
- url

### Methods

- addEventListener
- addListener
- close
- emit
- eventNames
- getMaxListeners
- listenerCount
- listeners
- off
- on
- once
- pause
- ping
- pong
- prependListener
- prependOnceListener
- rawListeners
- removeAllListeners
- removeEventListener
- removeListener
- resume
- send
- setMaxListeners
- terminate

## Properties

### Readonly CLOSED

CLOSED: 3

Inherited from WebSocketAlias.CLOSED

The connection is closed.

### Readonly CLOSING

CLOSING: 2

Inherited from WebSocketAlias.CLOSING

The connection is in the process of closing.

### Readonly CONNECTING

CONNECTING: 0

Inherited from WebSocketAlias.CONNECTING

The connection is not yet open.

### Readonly OPEN

OPEN: 1

Inherited from WebSocketAlias.OPEN

The connection is open and ready to communicate.

### binaryType

binaryType: "nodebuffer" | "arraybuffer" | "fragments"

Inherited from WebSocketAlias.binaryType

### Readonly bufferedAmount

bufferedAmount: number

Inherited from WebSocketAlias.bufferedAmount

### Readonly extensions

extensions: string

Inherited from WebSocketAlias.extensions

### Readonly isPaused

isPaused: boolean

Inherited from WebSocketAlias.isPaused

Indicates whether the websocket is paused

### onclose

onclose: (event: <internal>.CloseEvent) => void

Inherited from WebSocketAlias.onclose

#### Type declaration

- - (event: <internal>.CloseEvent): void

  - #### Parameters

    - ##### event: <internal>.CloseEvent

    #### Returns void

### onerror

onerror: (event: <internal>.ErrorEvent) => void

Inherited from WebSocketAlias.onerror

#### Type declaration

- - (event: <internal>.ErrorEvent): void

  - #### Parameters

    - ##### event: <internal>.ErrorEvent

    #### Returns void

### onmessage

onmessage: (event: <internal>.MessageEvent) => void

Inherited from WebSocketAlias.onmessage

#### Type declaration

- - (event: <internal>.MessageEvent): void

  - #### Parameters

    - ##### event: <internal>.MessageEvent

    #### Returns void

### onopen

onopen: (event: <internal>.Event) => void

Inherited from WebSocketAlias.onopen

#### Type declaration

- - (event: <internal>.Event): void

  - #### Parameters

    - ##### event: <internal>.Event

    #### Returns void

### Readonly protocol

protocol: string

Inherited from WebSocketAlias.protocol

### Readonly readyState

readyState: 0 | 2 | 1 | 3

Inherited from WebSocketAlias.readyState

The current state of the connection

### Readonly url

url: string

Inherited from WebSocketAlias.url

## Methods

### addEventListener

- addEventListener(method: "message", cb: (event: <internal>.MessageEvent) => void, options?: <internal>.EventListenerOptions): void
- addEventListener(method: "close", cb: (event: <internal>.CloseEvent) => void, options?: <internal>.EventListenerOptions): void
- addEventListener(method: "error", cb: (event: <internal>.ErrorEvent) => void, options?: <internal>.EventListenerOptions): void
- addEventListener(method: "open", cb: (event: <internal>.Event) => void, options?: <internal>.EventListenerOptions): void

- Inherited from WebSocketAlias.addEventListener

  #### Parameters

  - ##### method: "message"

  - ##### cb: (event: <internal>.MessageEvent) => void

    - - (event: <internal>.MessageEvent): void

      - #### Parameters

        - ##### event: <internal>.MessageEvent

        #### Returns void

  - ##### Optional options: <internal>.EventListenerOptions

  #### Returns void

- Inherited from WebSocketAlias.addEventListener

  #### Parameters

  - ##### method: "close"

  - ##### cb: (event: <internal>.CloseEvent) => void

    - - (event: <internal>.CloseEvent): void

      - #### Parameters

        - ##### event: <internal>.CloseEvent

        #### Returns void

  - ##### Optional options: <internal>.EventListenerOptions

  #### Returns void

- Inherited from WebSocketAlias.addEventListener

  #### Parameters

  - ##### method: "error"

  - ##### cb: (event: <internal>.ErrorEvent) => void

    - - (event: <internal>.ErrorEvent): void

      - #### Parameters

        - ##### event: <internal>.ErrorEvent

        #### Returns void

  - ##### Optional options: <internal>.EventListenerOptions

  #### Returns void

- Inherited from WebSocketAlias.addEventListener

  #### Parameters

  - ##### method: "open"

  - ##### cb: (event: <internal>.Event) => void

    - - (event: <internal>.Event): void

      - #### Parameters

        - ##### event: <internal>.Event

        #### Returns void

  - ##### Optional options: <internal>.EventListenerOptions

  #### Returns void

### addListener

- addListener(event: "close", listener: (code: number, reason: <internal>.Buffer) => void): <internal>.WebSocket
- addListener(event: "error", listener: (err: <internal>.Error) => void): <internal>.WebSocket
- addListener(event: "upgrade", listener: (request: IncomingMessage) => void): <internal>.WebSocket
- addListener(event: "message", listener: (data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocket
- addListener(event: "open", listener: () => void): <internal>.WebSocket
- addListener(event: "ping" | "pong", listener: (data: <internal>.Buffer) => void): <internal>.WebSocket
- addListener(event: "unexpected-response", listener: (request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocket
- addListener(event: string | symbol, listener: (...args: any[]) => void): <internal>.WebSocket

- Inherited from WebSocketAlias.addListener

  #### Parameters

  - ##### event: "close"

  - ##### listener: (code: number, reason: <internal>.Buffer) => void

    - - (code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.addListener

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.addListener

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (request: IncomingMessage) => void

    - - (request: IncomingMessage): void

      - #### Parameters

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.addListener

  #### Parameters

  - ##### event: "message"

  - ##### listener: (data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.addListener

  #### Parameters

  - ##### event: "open"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.addListener

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (data: <internal>.Buffer) => void

    - - (data: <internal>.Buffer): void

      - #### Parameters

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.addListener

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (request: ClientRequest, response: IncomingMessage) => void

    - - (request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.addListener

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocket

### close

- close(code?: number, data?: string | <internal>.Buffer): void

- Inherited from WebSocketAlias.close

  #### Parameters

  - ##### Optional code: number

  - ##### Optional data: string | <internal>.Buffer

  #### Returns void

### emit

- emit(eventName: string | symbol, ...args: any[]): boolean

- Inherited from WebSocketAlias.emit

  Synchronously calls each of the listeners registered for the event named`eventName`, in the order they were registered, passing the supplied arguments to each.

  Returns `true` if the event had listeners, `false` otherwise.

      const EventEmitter = require('events');
      const myEmitter = new EventEmitter();

      // First listener
      myEmitter.on('event', function firstListener() {
        console.log('Helloooo! first listener');
      });
      // Second listener
      myEmitter.on('event', function secondListener(arg1, arg2) {
        console.log(`event with parameters ${arg1}, ${arg2} in second listener`);
      });
      // Third listener
      myEmitter.on('event', function thirdListener(...args) {
        const parameters = args.join(', ');
        console.log(`event with parameters ${parameters} in third listener`);
      });

      console.log(myEmitter.listeners('event'));

      myEmitter.emit('event', 1, 2, 3, 4, 5);

      // Prints:
      // [
      //   [Function: firstListener],
      //   [Function: secondListener],
      //   [Function: thirdListener]
      // ]
      // Helloooo! first listener
      // event with parameters 1, 2 in second listener
      // event with parameters 1, 2, 3, 4, 5 in third listener

  since

    v0.1.26

  #### Parameters

  - ##### eventName: string | symbol

  - ##### Rest ...args: any[]

  #### Returns boolean

### eventNames

- eventNames(): (string | symbol)[]

- Inherited from WebSocketAlias.eventNames

  Returns an array listing the events for which the emitter has registered listeners. The values in the array are strings or `Symbol`s.

      const EventEmitter = require('events');
      const myEE = new EventEmitter();
      myEE.on('foo', () => {});
      myEE.on('bar', () => {});

      const sym = Symbol('symbol');
      myEE.on(sym, () => {});

      console.log(myEE.eventNames());
      // Prints: [ 'foo', 'bar', Symbol(symbol) ]

  since

    v6.0.0

  #### Returns (string | symbol)[]

### getMaxListeners

- getMaxListeners(): number

- Inherited from WebSocketAlias.getMaxListeners

  Returns the current max listener value for the `EventEmitter` which is either set by `emitter.setMaxListeners(n)` or defaults to defaultMaxListeners.

  since

    v1.0.0

  #### Returns number

### listenerCount

- listenerCount(eventName: string | symbol): number

- Inherited from WebSocketAlias.listenerCount

  Returns the number of listeners listening to the event named `eventName`.

  since

    v3.2.0

  #### Parameters

  - ##### eventName: string | symbol

    The name of the event being listened for

  #### Returns number

### listeners

- listeners(eventName: string | symbol): Function[]

- Inherited from WebSocketAlias.listeners

  Returns a copy of the array of listeners for the event named `eventName`.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });
      console.log(util.inspect(server.listeners('connection')));
      // Prints: [ [Function] ]

  since

    v0.1.26

  #### Parameters

  - ##### eventName: string | symbol

  #### Returns Function[]

### off

- off(event: "close", listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void): <internal>.WebSocket
- off(event: "error", listener: (this: <internal>.WebSocket, err: <internal>.Error) => void): <internal>.WebSocket
- off(event: "upgrade", listener: (this: <internal>.WebSocket, request: IncomingMessage) => void): <internal>.WebSocket
- off(event: "message", listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocket
- off(event: "open", listener: (this: <internal>.WebSocket) => void): <internal>.WebSocket
- off(event: "ping" | "pong", listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void): <internal>.WebSocket
- off(event: "unexpected-response", listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocket
- off(event: string | symbol, listener: (this: <internal>.WebSocket, ...args: any[]) => void): <internal>.WebSocket

- Inherited from WebSocketAlias.off

  #### Parameters

  - ##### event: "close"

  - ##### listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.off

  #### Parameters

  - ##### event: "error"

  - ##### listener: (this: <internal>.WebSocket, err: <internal>.Error) => void

    - - (this: <internal>.WebSocket, err: <internal>.Error): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.off

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (this: <internal>.WebSocket, request: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.off

  #### Parameters

  - ##### event: "message"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.off

  #### Parameters

  - ##### event: "open"

  - ##### listener: (this: <internal>.WebSocket) => void

    - - (this: <internal>.WebSocket): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.off

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, data: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.off

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.off

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (this: <internal>.WebSocket, ...args: any[]) => void

    - - (this: <internal>.WebSocket, ...args: any[]): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocket

### on

- on(event: "close", listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void): <internal>.WebSocket
- on(event: "error", listener: (this: <internal>.WebSocket, err: <internal>.Error) => void): <internal>.WebSocket
- on(event: "upgrade", listener: (this: <internal>.WebSocket, request: IncomingMessage) => void): <internal>.WebSocket
- on(event: "message", listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocket
- on(event: "open", listener: (this: <internal>.WebSocket) => void): <internal>.WebSocket
- on(event: "ping" | "pong", listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void): <internal>.WebSocket
- on(event: "unexpected-response", listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocket
- on(event: string | symbol, listener: (this: <internal>.WebSocket, ...args: any[]) => void): <internal>.WebSocket

- Inherited from WebSocketAlias.on

  #### Parameters

  - ##### event: "close"

  - ##### listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.on

  #### Parameters

  - ##### event: "error"

  - ##### listener: (this: <internal>.WebSocket, err: <internal>.Error) => void

    - - (this: <internal>.WebSocket, err: <internal>.Error): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.on

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (this: <internal>.WebSocket, request: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.on

  #### Parameters

  - ##### event: "message"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.on

  #### Parameters

  - ##### event: "open"

  - ##### listener: (this: <internal>.WebSocket) => void

    - - (this: <internal>.WebSocket): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.on

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, data: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.on

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.on

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (this: <internal>.WebSocket, ...args: any[]) => void

    - - (this: <internal>.WebSocket, ...args: any[]): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocket

### once

- once(event: "close", listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void): <internal>.WebSocket
- once(event: "error", listener: (this: <internal>.WebSocket, err: <internal>.Error) => void): <internal>.WebSocket
- once(event: "upgrade", listener: (this: <internal>.WebSocket, request: IncomingMessage) => void): <internal>.WebSocket
- once(event: "message", listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocket
- once(event: "open", listener: (this: <internal>.WebSocket) => void): <internal>.WebSocket
- once(event: "ping" | "pong", listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void): <internal>.WebSocket
- once(event: "unexpected-response", listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocket
- once(event: string | symbol, listener: (this: <internal>.WebSocket, ...args: any[]) => void): <internal>.WebSocket

- Inherited from WebSocketAlias.once

  #### Parameters

  - ##### event: "close"

  - ##### listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.once

  #### Parameters

  - ##### event: "error"

  - ##### listener: (this: <internal>.WebSocket, err: <internal>.Error) => void

    - - (this: <internal>.WebSocket, err: <internal>.Error): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.once

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (this: <internal>.WebSocket, request: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.once

  #### Parameters

  - ##### event: "message"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.once

  #### Parameters

  - ##### event: "open"

  - ##### listener: (this: <internal>.WebSocket) => void

    - - (this: <internal>.WebSocket): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.once

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, data: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.once

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.once

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (this: <internal>.WebSocket, ...args: any[]) => void

    - - (this: <internal>.WebSocket, ...args: any[]): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocket

### pause

- pause(): void

- Inherited from WebSocketAlias.pause

  Pause the websocket causing it to stop emitting events. Some events can still be emitted after this is called, until all buffered data is consumed. This method is a noop if the ready state is `CONNECTING` or `CLOSED`.

  #### Returns void

### ping

- ping(data?: any, mask?: boolean, cb?: (err: <internal>.Error) => void): void

- Inherited from WebSocketAlias.ping

  #### Parameters

  - ##### Optional data: any

  - ##### Optional mask: boolean

  - ##### Optional cb: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

### pong

- pong(data?: any, mask?: boolean, cb?: (err: <internal>.Error) => void): void

- Inherited from WebSocketAlias.pong

  #### Parameters

  - ##### Optional data: any

  - ##### Optional mask: boolean

  - ##### Optional cb: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

### prependListener

- prependListener(eventName: string | symbol, listener: (...args: any[]) => void): <internal>.WebSocket

- Inherited from WebSocketAlias.prependListener

  Adds the `listener` function to the beginning of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName`and `listener` will result in the `listener` being added, and called, multiple times.

      server.prependListener('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v6.0.0

  #### Parameters

  - ##### eventName: string | symbol

    The name of the event.

  - ##### listener: (...args: any[]) => void

    The callback function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocket

### prependOnceListener

- prependOnceListener(eventName: string | symbol, listener: (...args: any[]) => void): <internal>.WebSocket

- Inherited from WebSocketAlias.prependOnceListener

  Adds a one-time `listener` function for the event named `eventName` to the_beginning_ of the listeners array. The next time `eventName` is triggered, this listener is removed, and then invoked.

      server.prependOnceListener('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v6.0.0

  #### Parameters

  - ##### eventName: string | symbol

    The name of the event.

  - ##### listener: (...args: any[]) => void

    The callback function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocket

### rawListeners

- rawListeners(eventName: string | symbol): Function[]

- Inherited from WebSocketAlias.rawListeners

  Returns a copy of the array of listeners for the event named `eventName`, including any wrappers (such as those created by `.once()`).

      const emitter = new EventEmitter();
      emitter.once('log', () => console.log('log once'));

      // Returns a new Array with a function `onceWrapper` which has a property
      // `listener` which contains the original listener bound above
      const listeners = emitter.rawListeners('log');
      const logFnWrapper = listeners[0];

      // Logs "log once" to the console and does not unbind the `once` event
      logFnWrapper.listener();

      // Logs "log once" to the console and removes the listener
      logFnWrapper();

      emitter.on('log', () => console.log('log persistently'));
      // Will return a new Array with a single function bound by `.on()` above
      const newListeners = emitter.rawListeners('log');

      // Logs "log persistently" twice
      newListeners[0]();
      emitter.emit('log');

  since

    v9.4.0

  #### Parameters

  - ##### eventName: string | symbol

  #### Returns Function[]

### removeAllListeners

- removeAllListeners(event?: string | symbol): <internal>.WebSocket

- Inherited from WebSocketAlias.removeAllListeners

  Removes all listeners, or those of the specified `eventName`.

  It is bad practice to remove listeners added elsewhere in the code, particularly when the `EventEmitter` instance was created by some other component or module (e.g. sockets or file streams).

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v0.1.26

  #### Parameters

  - ##### Optional event: string | symbol

  #### Returns <internal>.WebSocket

### removeEventListener

- removeEventListener(method: "message", cb: (event: <internal>.MessageEvent) => void): void
- removeEventListener(method: "close", cb: (event: <internal>.CloseEvent) => void): void
- removeEventListener(method: "error", cb: (event: <internal>.ErrorEvent) => void): void
- removeEventListener(method: "open", cb: (event: <internal>.Event) => void): void

- Inherited from WebSocketAlias.removeEventListener

  #### Parameters

  - ##### method: "message"

  - ##### cb: (event: <internal>.MessageEvent) => void

    - - (event: <internal>.MessageEvent): void

      - #### Parameters

        - ##### event: <internal>.MessageEvent

        #### Returns void

- Inherited from WebSocketAlias.removeEventListener

  #### Parameters

  - ##### method: "close"

  - ##### cb: (event: <internal>.CloseEvent) => void

    - - (event: <internal>.CloseEvent): void

      - #### Parameters

        - ##### event: <internal>.CloseEvent

        #### Returns void

- Inherited from WebSocketAlias.removeEventListener

  #### Parameters

  - ##### method: "error"

  - ##### cb: (event: <internal>.ErrorEvent) => void

    - - (event: <internal>.ErrorEvent): void

      - #### Parameters

        - ##### event: <internal>.ErrorEvent

        #### Returns void

- Inherited from WebSocketAlias.removeEventListener

  #### Parameters

  - ##### method: "open"

  - ##### cb: (event: <internal>.Event) => void

    - - (event: <internal>.Event): void

      - #### Parameters

        - ##### event: <internal>.Event

        #### Returns void

### removeListener

- removeListener(event: "close", listener: (code: number, reason: <internal>.Buffer) => void): <internal>.WebSocket
- removeListener(event: "error", listener: (err: <internal>.Error) => void): <internal>.WebSocket
- removeListener(event: "upgrade", listener: (request: IncomingMessage) => void): <internal>.WebSocket
- removeListener(event: "message", listener: (data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocket
- removeListener(event: "open", listener: () => void): <internal>.WebSocket
- removeListener(event: "ping" | "pong", listener: (data: <internal>.Buffer) => void): <internal>.WebSocket
- removeListener(event: "unexpected-response", listener: (request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocket
- removeListener(event: string | symbol, listener: (...args: any[]) => void): <internal>.WebSocket

- Inherited from WebSocketAlias.removeListener

  #### Parameters

  - ##### event: "close"

  - ##### listener: (code: number, reason: <internal>.Buffer) => void

    - - (code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.removeListener

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.removeListener

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (request: IncomingMessage) => void

    - - (request: IncomingMessage): void

      - #### Parameters

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.removeListener

  #### Parameters

  - ##### event: "message"

  - ##### listener: (data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.removeListener

  #### Parameters

  - ##### event: "open"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.removeListener

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (data: <internal>.Buffer) => void

    - - (data: <internal>.Buffer): void

      - #### Parameters

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.removeListener

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (request: ClientRequest, response: IncomingMessage) => void

    - - (request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocket

- Inherited from WebSocketAlias.removeListener

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocket

### resume

- resume(): void

- Inherited from WebSocketAlias.resume

  Make a paused socket resume emitting events. This method is a noop if the ready state is `CONNECTING` or `CLOSED`.

  #### Returns void

### send

- send(data: any, cb?: (err?: <internal>.Error) => void): void
- send(data: any, options: { binary?: boolean; compress?: boolean; fin?: boolean; mask?: boolean }, cb?: (err?: <internal>.Error) => void): void

- Inherited from WebSocketAlias.send

  #### Parameters

  - ##### data: any

  - ##### Optional cb: (err?: <internal>.Error) => void

    - - (err?: <internal>.Error): void

      - #### Parameters

        - ##### Optional err: <internal>.Error

        #### Returns void

- Inherited from WebSocketAlias.send

  #### Parameters

  - ##### data: any

  - ##### options: { binary?: boolean; compress?: boolean; fin?: boolean; mask?: boolean }

    - ##### Optional binary?: boolean

    - ##### Optional compress?: boolean

    - ##### Optional fin?: boolean

    - ##### Optional mask?: boolean

  - ##### Optional cb: (err?: <internal>.Error) => void

    - - (err?: <internal>.Error): void

      - #### Parameters

        - ##### Optional err: <internal>.Error

        #### Returns void

### setMaxListeners

- setMaxListeners(n: number): <internal>.WebSocket

- Inherited from WebSocketAlias.setMaxListeners

  By default `EventEmitter`s will print a warning if more than `10` listeners are added for a particular event. This is a useful default that helps finding memory leaks. The `emitter.setMaxListeners()` method allows the limit to be modified for this specific `EventEmitter` instance. The value can be set to`Infinity` (or `0`) to indicate an unlimited number of listeners.

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v0.3.5

  #### Parameters

  - ##### n: number

  #### Returns <internal>.WebSocket

### terminate

- terminate(): void

- Inherited from WebSocketAlias.terminate

  #### Returns void

Generated using TypeDoc